"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const repo_1 = __importDefault(require("../repo"));
const node_1 = require("../node");
const MemoryDatastore = require('interface-datastore').MemoryDatastore;
const community_1 = require("./community");
const debug_1 = __importDefault(require("debug"));
const constants_spec_1 = require("../constants.spec");
const log = debug_1.default('community:local');
/**
 *
 * @internal
 */
exports._freshLocalTestCommunity = (repo) => __awaiter(void 0, void 0, void 0, function* () {
    return new Promise((resolve, reject) => __awaiter(void 0, void 0, void 0, function* () {
        if (repo == undefined) {
            repo = new repo_1.default('test', {
                lock: 'memory',
                storageBackends: {
                    root: MemoryDatastore,
                    blocks: MemoryDatastore,
                    keys: MemoryDatastore,
                    datastore: MemoryDatastore
                }
            });
            yield repo.init({});
            yield repo.open();
        }
        const node = yield node_1.p2p.createNode({ bootstrapAddresses: constants_spec_1.testNotaryGroup.getBootstrapAddressesList() });
        node.on('error', (err) => {
            reject(err);
            console.error('p2p error: ', err);
        });
        const c = new community_1.Community(node, constants_spec_1.testNotaryGroup, repo.repo);
        node.start(() => __awaiter(void 0, void 0, void 0, function* () {
            log("node started");
            resolve(c.start());
        }));
    }));
});
