import { IDataStore } from '../chaintree/datastore';
import Repo from '../repo';
import { Community } from '../community/community';
import { NotaryGroup } from 'tupelo-messages';
import { Transaction } from 'tupelo-messages/transactions/transactions_pb';
import { GenerateKeyResponse, ListKeysResponse, GenerateChainResponse, ListChainIdsResponse, GetTipResponse, PlayTransactionsResponse } from 'tupelo-messages/services/services_pb';
import { IP2PNode } from '../node';
interface ITupeloClientOptions {
    keystore: IDataStore;
    blockstore: IDataStore;
    notaryGroup: NotaryGroup;
}
export declare class TupeloClient {
    repo: Repo;
    notaryGroup: NotaryGroup;
    community?: Community;
    node?: IP2PNode;
    constructor(opts: ITupeloClientOptions);
    start(): Promise<void>;
    close(): Promise<void>;
    register(): Promise<void>;
    generateKey(): Promise<GenerateKeyResponse>;
    listKeys(): Promise<ListKeysResponse>;
    createChainTree(keyAddr: string): Promise<GenerateChainResponse>;
    listChainIds(): Promise<ListChainIdsResponse>;
    getTip(chainId: string): Promise<GetTipResponse>;
    playTransactions(chainId: string, keyAddr: string, transactions: Transaction[]): Promise<PlayTransactionsResponse>;
    private _getKey;
    private _startCommunity;
    private _createRepo;
}
export {};
//# sourceMappingURL=legacy.d.ts.map